local _Questic = _Questic_ADDON_Globals;
local Widgets = _Avyr_GUI_Widgets_Lib;
local _Avyr_GUI_Widgets_Tooltip = _Avyr_GUI_Widgets_Tooltip;
local Padding = Widgets.Padding;
local GetContainerItemInfo, GetContainerItemCooldown, GetTime, GetBindingText, GetBindingKey, _G, UIParent, InCombatLockdown, getn, GetItemInfo, select, CreateFrame, type = GetContainerItemInfo, GetContainerItemCooldown, GetTime, GetBindingText, GetBindingKey, _G, UIParent, InCombatLockdown, getn, GetItemInfo, select, CreateFrame, type;
local insert = table.insert;

_Questic.QuestItemBar = {}
local ItemBarFuncs = _Questic.QuestItemBar

local ItemBar

local MaxQuestItemsToBeDisplayed = 20;
local UpdateAfterCombat = false;
local ShowPreview = false;

local ItemNumButtons = 0


--local texture, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID = GetContainerItemInfo(Bag,Slot);
local function UpdateQuestItemTexture(self, Index)
    if not self.QuestItemOverlay then
        self.QuestItemOverlay = Widgets:CreateFrame(self);
        self.QuestItemOverlay:SetAllPoints();
        self.QuestItemOverlay:Backdrop();
    end
    if _Questic.GetVariable("QuestItemBarShowCD") and not self.QuestItemOverlay.CooldownFrame then
        self.QuestItemOverlay.CooldownFrame = Widgets:CreateCooldownFrame(self.QuestItemOverlay)
    elseif not _Questic.GetVariable("QuestItemBarShowCD") and self.QuestItemOverlay.CooldownFrame then
        self.QuestItemOverlay.CooldownFrame:Release();
        self.QuestItemOverlay.CooldownFrame = nil;
    end
    local Texture = 136243
    local Count = 3;
    if self.BagID and self.SlotID then
        Texture, Count = GetContainerItemInfo(self.BagID, self.SlotID);
        Count = Count or 1;
        if self.QuestItemOverlay.CooldownFrame then
            local startTime, duration, isEnabled = GetContainerItemCooldown(self.BagID, self.SlotID);
            self.QuestItemOverlay.CooldownFrame:SetCooldown(startTime, duration);
            self.QuestItemOverlay.CooldownFrame.OnFinished = function()
                local startTime, duration, isEnabled = GetContainerItemCooldown(self.BagID, self.SlotID);
                self.QuestItemOverlay.CooldownFrame:SetCooldown(startTime, duration);
            end
        end
    elseif self.QuestItemOverlay.CooldownFrame then
        self.QuestItemOverlay.CooldownFrame:SetCooldown(GetTime(), 5);
        self.QuestItemOverlay.CooldownFrame.OnFinished = function()
            self.QuestItemOverlay.CooldownFrame:SetCooldown(GetTime(), 5);
        end
    end
    self.QuestItemOverlay:SetIcon(Texture, 0.1, 0.9, 0.1, 0.9);
    if Count > 1 and _Questic.GetVariable("QuestItemBarShowCount") then
        if Index and Index < 7 and _Questic.GetVariable("QuestItemBarShowKeyBinding") then
            self.QuestItemOverlay:SetText(Count, 18, 1, 1, 1, "RIGHT", "BOTTOM", GetBindingText(GetBindingKey("CLICK QUESTIC_ADDON_ITEMBAR_ITEM" .. Index .. ":LeftButton"), "KEY_", true), 12, 1, 1, 1, "LEFT", "TOP")
        else
            self.QuestItemOverlay:SetText(Count, 18, 1, 1, 1, "RIGHT", "BOTTOM");
        end
    else
        if Index and Index < 7 and _Questic.GetVariable("QuestItemBarShowKeyBinding") then
            self.QuestItemOverlay:SetText(GetBindingText(GetBindingKey("CLICK QUESTIC_ADDON_ITEMBAR_ITEM" .. Index .. ":LeftButton"), "KEY_", true), 12, 1, 1, 1, "LEFT", "TOP")
        else
            self.QuestItemOverlay:SetText()
        end
    end

    insert(self.QuestItemOverlay.LM,"CooldownFrame");
end

ItemBarFuncs.UpdateItemBarOverlay = function()
    for i = 1, MaxQuestItemsToBeDisplayed do
        if _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i] and _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:IsShown() then
            UpdateQuestItemTexture(_G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i], i);
        end
    end
end

ItemBarFuncs.Update = function(ForceReset)
    if not ItemBar then
        if _Questic.GetVariable("QuestItemBar") and _Questic.GetVariable("Enable") then
            ItemBar = Widgets:CreateFrame(UIParent)
            ItemBar:Size(60, 60)
            ItemBar:SetScript("OnEvent", function(self, Event)
                if Event == "PLAYER_REGEN_ENABLED" then
                    if UpdateAfterCombat then
                        ItemBarFuncs.Update()
                    end
                elseif Event == "PLAYER_REGEN_DISABLED" then
                end
            end)
            ItemBar:RegisterEvent("PLAYER_REGEN_ENABLED")

            insert(ItemBar.LM,"ClosePreviewButton");

            ItemBar.OnMove = function(self)
                local _, _, _, x, y = self:GetPoint(1)
                if _Questic.GetVariable("QuestItemBarPositionx") and _Questic.GetVariable("QuestItemBarPositiony") then
                    _Questic.SaveVariable("QuestItemBarPositionx", x)
                    _Questic.SaveVariable("QuestItemBarPositiony", y)
                end
            end
        end
    end

    if not ItemBar then 
        return nil 
    end

    if ItemBar and ShowPreview then
        ItemBarFuncs.ShowPreviewFrame(nil, true);
    end

    if ForceReset then
        _Questic.SaveVariable("QuestItemBarPositionx", nil)
        _Questic.SaveVariable("QuestItemBarPositiony", nil)
    end

    if InCombatLockdown() then
        UpdateAfterCombat = true;
        return nil;
    end

    if ItemBar and (not _Questic.GetVariable("QuestItemBar") or not _Questic.GetVariable("Enable")) then
        for i = 1, MaxQuestItemsToBeDisplayed do
            if _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i] then
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:Hide();
            end
        end
        ItemBarFuncs.ShowPreviewFrame(false);
        ItemBar:UnregisterAllEvents()
        ItemBar:Release()
        ItemBar = nil
        return nil
    end

    local x, y = _Questic.GetVariable("QuestItemBarPositionx"), _Questic.GetVariable("QuestItemBarPositiony");
    if not x or not y then
        x, y = UIParent:GetCenter();
        if not x then
            x = (x - ItemBar:GetWidth() / 2);
        end
        if not y then
            y = (y + ItemBar:GetHeight() / 2);
        end
    else
        local PrevScale = ItemBar:GetScale();
        x = x * PrevScale;
        y = y * PrevScale;
    end

    local i = 1;
    for ItemIndex = 1, getn(_Questic.QuestItemList) do
        if not _Questic.QuestItemBlackList("Check", GetItemInfo(select(7, GetContainerItemInfo(_Questic.QuestItemList[ItemIndex].BagID, _Questic.QuestItemList[ItemIndex].SlotID)))) and (_Questic.GetVariable("QuestItemBarMaxItemsDisplayed") == 0 or i <= _Questic.GetVariable("QuestItemBarMaxItemsDisplayed")) and i <= MaxQuestItemsToBeDisplayed then
            if not _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i] then
                ItemNumButtons = ItemNumButtons + 1;
                CreateFrame("Button", "QUESTIC_ADDON_ITEMBAR_ITEM" .. i, UIParent, "SecureActionButtonTemplate")
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetSize(60, 60)
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetAttribute("type", "macro")
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:RegisterForClicks("LeftButtonDown", "RightButtonDown");
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetScript("OnHide", function(self)
                    if self.QuestItemOverlay then
                        self.QuestItemOverlay:Release()
                        self.QuestItemOverlay = nil;
                    end
                end)
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetScript("OnEnter",function(self)
                    local itemLink = select(7,GetContainerItemInfo(self.BagID,self.SlotID));
                    _Avyr_GUI_Widgets_Tooltip:SetTT(self);
                    --_Avyr_GUI_Widgets_Tooltip:SetBagItem(self.BsgID,self.SlotID);
                    _Avyr_GUI_Widgets_Tooltip:SetHyperlink(itemLink);
                end)
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetScript("OnLeave",function(self)
                    _Avyr_GUI_Widgets_Tooltip:Hide();
                end)
            else
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:Show();
            end
            _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i].BagID = _Questic.QuestItemList[ItemIndex].BagID;
            _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i].SlotID = _Questic.QuestItemList[ItemIndex].SlotID;
            UpdateQuestItemTexture(_G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i], i);
            _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetAttribute("macrotext", "/use " .. GetItemInfo(select(7, GetContainerItemInfo(_Questic.QuestItemList[ItemIndex].BagID, _Questic.QuestItemList[ItemIndex].SlotID))));

            i = i + 1;
        end
    end
    if i < MaxQuestItemsToBeDisplayed then
        for btn = i, MaxQuestItemsToBeDisplayed do
            if _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. btn] then
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. btn]:Hide();
            end
        end
    end


    local NewScale = _Questic.GetVariable("QuestItemBarScale");
    for i = 1, ItemNumButtons do
        if _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i] then
            _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetScale(NewScale);
            if i ~= 1 then
                _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:ClearAllPoints();
                if _Questic.GetVariable("QuestItemBarGrowthDirection") == "Down" then
                    _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetPoint("TOP", _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i - 1], "BOTTOM", 0, -Padding);
                elseif _Questic.GetVariable("QuestItemBarGrowthDirection") == "Up" then
                    _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetPoint("BOTTOM", _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i - 1], "TOP", 0, Padding);
                elseif _Questic.GetVariable("QuestItemBarGrowthDirection") == "Left" then
                    _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetPoint("RIGHT", _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i - 1], "LEFT", -Padding, 0);
                else
                    _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i]:SetPoint("LEFT", _G["QUESTIC_ADDON_ITEMBAR_ITEM" .. i - 1], "RIGHT", Padding, 0);
                end
            end
        end
    end
    ItemBar:SetScale(NewScale);
    x = x / NewScale;
    y = y / NewScale;
    ItemBar:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x, y);

    if _G["QUESTIC_ADDON_ITEMBAR_ITEM1"] then
        _G["QUESTIC_ADDON_ITEMBAR_ITEM1"]:ClearAllPoints()
        if _Questic.GetVariable("QuestItemBarGrowthDirection") == "Down" then
            _G["QUESTIC_ADDON_ITEMBAR_ITEM1"]:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x, y - ItemBar:GetHeight() - Padding);
        elseif _Questic.GetVariable("QuestItemBarGrowthDirection") == "Up" then
            _G["QUESTIC_ADDON_ITEMBAR_ITEM1"]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", x, y + Padding);
        elseif _Questic.GetVariable("QuestItemBarGrowthDirection") == "Left" then
            _G["QUESTIC_ADDON_ITEMBAR_ITEM1"]:SetPoint("TOPRIGHT", UIParent, "BOTTOMLEFT", x - Padding, y);
        else
            _G["QUESTIC_ADDON_ITEMBAR_ITEM1"]:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x + ItemBar:GetWidth() + Padding, y);
        end
    end

    if x ~= _Questic.GetVariable("QuestItemBarPositionx") then
        _Questic.SaveVariable("QuestItemBarPositionx", x)
    end
    if _Questic.GetVariable("QuestItemBarPositiony") ~= y then
        _Questic.SaveVariable("QuestItemBarPositiony", y)
    end
    UpdateAfterCombat = false
end

ItemBarFuncs.ShowPreviewFrame = function(Show, Refresh)
    if type(Show) == "nil" and not Refresh then Show = not ShowPreview end
    if type(Show) == "nil" and Refresh then Show = ShowPreview end
    if ItemBar then
        if Show then
            ItemBar:Backdrop()
            if not ItemBar.ClosePreviewButton then
                ItemBar.ClosePreviewButton = Widgets:CreateButton(ItemBar)
                ItemBar.ClosePreviewButton:SetPoint("TOPRIGHT");
                ItemBar.ClosePreviewButton:Size(20, 20);
                ItemBar.ClosePreviewButton:CloseButtonTexture();
                ItemBar.ClosePreviewButton.Tooltip = "Untoggle Item bar preview."
                ItemBar.ClosePreviewButton.OnClick = function()
                    ItemBarFuncs.ShowPreviewFrame(false)
                end
            end
            if InCombatLockdown() then
                ItemBar:SetText("Combat lock")
            else
                ItemBar:SetText("Move me!")
            end
            ItemBar:MakeMovable(true)
            local MaxItems = _Questic.GetVariable("QuestItemBarMaxItemsDisplayed")
            MaxItems = MaxItems == 0 and 5 or MaxItems
            for i = 1, MaxItems do
                if not ItemBar["PreviewFrame" .. i] then
                    ItemBar["PreviewFrame" .. i] = Widgets:CreateFrame(ItemBar);
                    ItemBar["PreviewFrame" .. i]:Size(60, 60);
                end
                UpdateQuestItemTexture(ItemBar["PreviewFrame" .. i], i);

                insert(ItemBar["PreviewFrame" .. i].LM,"QuestItemOverlay")

                ItemBar["PreviewFrame" .. i]:ClearAllPoints();
                if i == 1 then
                    if _Questic.GetVariable("QuestItemBarGrowthDirection") == "Down" then
                        ItemBar["PreviewFrame" .. i]:SetPoint("TOP", ItemBar, "BOTTOM", 0, -Padding);
                    elseif _Questic.GetVariable("QuestItemBarGrowthDirection") == "Up" then
                        ItemBar["PreviewFrame" .. i]:SetPoint("BOTTOM", ItemBar, "TOP", 0, Padding);
                    elseif _Questic.GetVariable("QuestItemBarGrowthDirection") == "Left" then
                        ItemBar["PreviewFrame" .. i]:SetPoint("RIGHT", ItemBar, "LEFT", -Padding, 0);
                    else
                        ItemBar["PreviewFrame" .. i]:SetPoint("LEFT", ItemBar, "RIGHT", Padding, 0);
                    end
                else
                    if _Questic.GetVariable("QuestItemBarGrowthDirection") == "Down" then
                        ItemBar["PreviewFrame" .. i]:SetPoint("TOP", ItemBar["PreviewFrame" .. i - 1], "BOTTOM", 0, -Padding);
                    elseif _Questic.GetVariable("QuestItemBarGrowthDirection") == "Up" then
                        ItemBar["PreviewFrame" .. i]:SetPoint("BOTTOM", ItemBar["PreviewFrame" .. i - 1], "TOP", 0, Padding);
                    elseif _Questic.GetVariable("QuestItemBarGrowthDirection") == "Left" then
                        ItemBar["PreviewFrame" .. i]:SetPoint("RIGHT", ItemBar["PreviewFrame" .. i - 1], "LEFT", -Padding, 0);
                    else
                        ItemBar["PreviewFrame" .. i]:SetPoint("LEFT", ItemBar["PreviewFrame" .. i - 1], "RIGHT", Padding, 0);
                    end
                end
            end
            if MaxItems + 1 < MaxQuestItemsToBeDisplayed then
                for i = MaxItems + 1, MaxQuestItemsToBeDisplayed do
                    if ItemBar["PreviewFrame" .. i] then
                        ItemBar["PreviewFrame" .. i]:Release();
                        ItemBar["PreviewFrame" .. i] = nil;
                    end
                end
            end
        else
            ItemBar:Backdrop("Clear")
            if ItemBar.ClosePreviewButton then
                ItemBar.ClosePreviewButton:Release();
                ItemBar.ClosePreviewButton = nil
            end
            ItemBar:SetText("")
            ItemBar:MakeMovable(false)
            for i = 1, MaxQuestItemsToBeDisplayed do
                if ItemBar["PreviewFrame" .. i] then
                    ItemBar["PreviewFrame" .. i]:Release();
                    ItemBar["PreviewFrame" .. i] = nil;
                end
            end
        end
    end
    ShowPreview = Show
end
