local _Questic = _Questic_ADDON_Globals
_Avyr_GUI_Widgets_Lib:Initialize("Questic")

_Questic_ADDON_Globals.AddonName = "Questic"
_Questic_ADDON_Globals.AddonComsPrefix = "Questic"

--_Questic_ADDON_Globals.SV = {};
--_Questic_ADDON_Globals.SV.Enable = false; --Disable until settings are fully loaded

--local OverrideSelectedProfile;

_Questic.OptionsTabs = {}

_Questic.RouteData = {}
_Questic.RouteData.Continents = {}
_Questic.RouteData.DefaultRoutes = {}
_Questic.RouteData.ZoneRefPoints = {}
_Questic.RouteData.QuestHubs = {}
_Questic.RouteData.Quests = {}
_Questic.RouteData.Maps = {}
_Questic.RouteData.Zones = {}
_Questic.RouteData.Skips = {}
_Questic.RouteData.Dungeons = {}

_Questic.RouteData.Routes = {}
_Questic.RouteData.RouteLayout = {}
_Questic.RouteData.Chains = {}

local OutTable = {}
local ProcessingTable = {}
_Questic_ADDON_Globals.FetchQuestInformation = function(QuestID, Type)
	if _Questic.RouteData.Quests[QuestID] then
		local QuestFaction,
			QuestName,
			Exp,
			Rep,
			Accept,
			Objective,
			TurnIn,
			UnlockedBy,
			Unlocks,
			LockedBy,
			Locks,
			Choice,
			GroupInfo = strsplit("|", _Questic.RouteData.Quests[QuestID])
		if Type == "Name" then
			return QuestName
		elseif Type == "Exp" then
			local ExpType, ExpClass = strsplit(":", Exp)
			local ExpClass = tonumber(ExpClass)
			if ExpType and ExpClass then
				return ExpType, ExpClass
			end
		elseif Type == "Rep" then
			table.wipe(ProcessingTable)
			ProcessingTable = {strsplit(":", Rep)}
			local OutTable = {}
			local OutVariable
			for i, v in ipairs(ProcessingTable) do
				local FactionID, FactionAmount = strsplit("#", v)
				FactionAmount = tonumber(FactionAmount)
				FactionID = tonumber(FactionID)
				if FactionAmount and FactionID then
					if OutVariable then
						OutVariable = OutVariable, FactionID, FactionAmount
					else
						OutVariable = FactionID, FactionAmount
					end
					table.insert(OutTable, {ID = FactionID, Amount = FactionAmount})
				end
			end
			return OutTable
		elseif Type == "Accept" then
			local x, y, Zone = strsplit(":", Accept)
			x = tonumber(x)
			y = tonumber(y)
			if x and y and Zone then
				return x, y, Zone
			end
		elseif Type == "Objective" then
			table.wipe(ProcessingTable)
			local OutTable = {}
			ProcessingTable = {strsplit(":", Objective)}
			for i, v in ipairs(ProcessingTable) do
				local x, y, Zone, Area, Boss = strsplit("#", v)
				x = tonumber(x)
				y = tonumber(y)
				Area = tonumber(Area)
				if Boss then
					table.insert(OutTable, {x = x, y = y, Zone = Zone, Area = Area, Boss = true})
				else
					table.insert(OutTable, {x = x, y = y, Zone = Zone, Area = Area})
				end
			end
			return OutTable
		elseif Type == "TurnIn" then
			local x, y, Zone = strsplit(":", TurnIn)
			x = tonumber(x)
			y = tonumber(y)
			if x and y and Zone then
				return x, y, Zone
			end
		elseif Type == "UnlockedBy" then
			local OutTable = {}
			table.wipe(ProcessingTable)
			ProcessingTable = {strsplit(":", UnlockedBy)}
			for _, QuestID in ipairs(ProcessingTable) do
				local QuestNum = tonumber(QuestID)
				if QuestNum then
					table.insert(OutTable, QuestNum)
				end
			end
			return OutTable
		elseif Type == "Unlocks" then
			local OutTable = {}
			table.wipe(ProcessingTable)
			ProcessingTable = {strsplit(":", Unlocks)}
			for _, QuestID in ipairs(ProcessingTable) do
				local QuestNum = tonumber(QuestID)
				if QuestNum then
					table.insert(OutTable, QuestNum)
				end
			end
			return OutTable
		elseif Type == "LockedBy" then
			local OutTable = {}
			table.wipe(ProcessingTable)
			ProcessingTable = {strsplit(":", LockedBy)}
			for _, QuestID in ipairs(ProcessingTable) do
				local QuestNum = tonumber(QuestID)
				if QuestNum then
					table.insert(OutTable, QuestNum)
				end
			end
			return OutTable
		elseif Type == "Locks" then
			local OutTable = {}
			table.wipe(ProcessingTable)
			ProcessingTable = {strsplit(":", Locks)}
			for _, QuestID in ipairs(ProcessingTable) do
				local QuestNum = tonumber(QuestID)
				if QuestNum then
					table.insert(OutTable, QuestNum)
				end
			end
			return OutTable
		elseif Type == "Choice" then
			local OutTable = {}
			table.wipe(ProcessingTable)
			ProcessingTable = {strsplit(":", Choice)}
			for _, QuestID in ipairs(ProcessingTable) do
				local QuestNum = tonumber(QuestID)
				if QuestNum then
					table.insert(OutTable, QuestNum)
				end
			end
			return OutTable
		elseif Type == "GroupInfo" then
			if tonumber(GroupInfo) then
				return tonumber(GroupInfo)
			else
				return GroupInfo
			end
		end
	else
		return nil
	end
end

_Questic.GetRouteStageInfo = function(self, StageString)
	if type(StageString) ~= "string" then
		return nil
	end
	local Hub, BonusType, BonusQuests = strsplit("|", StageString)
	local HubData = ""
	for LocFacString, Hubs in pairs(_Questic.RouteData.QuestHubs) do
		if Hubs[Hub] then
			HubData = Hubs[Hub]
		end
	end
	local QuestsInStage = {}
	--print(StageString)
	if not BonusType then
		local Name, x, y, Zone, QuestsData, Sources, Destinations = strsplit("|", HubData)
		local Quests = {strsplit("#", QuestsData)}
		for i, v in ipairs(Quests) do
			local QuestID = tonumber(v)
			if tonumber(QuestID) then
				--print(QuestID)
				table.insert(QuestsInStage, QuestID)
			end
		end
	else
		if BonusType == "i" then
			local Quests = {strsplit("#", BonusQuests)}
			for i, v in ipairs(Quests) do
				local QuestID = tonumber(v)
				if tonumber(QuestID) then
					--print(QuestID)
					table.insert(QuestsInStage, QuestID)
				end
			end
		else
			QuestsInStage = _Questic.GetRouteStageInfo(self, Hub)
			local IgnoreQuests = _Questic.GetRouteStageInfo(self, Hub .. "|i|" .. BonusQuests)
			for i, v in ipairs(IgnoreQuests) do
				local removeIndex = 0
				for ri, rv in ipairs(QuestsInStage) do
					if rv == v then
						removeIndex = ri
						break
					end
				end
				table.remove(QuestsInStage, removeIndex)
			end
		end
	end
	return QuestsInStage
end

function _Questic.GetFactionInfoByID(ID)
	return GetFactionInfoByID(ID) or ID
end

local DelayTime = 0.2

local DelayFrame = CreateFrame("FRAME")
DelayFrame:Hide()

local DelayCallBacks = {}

DelayFrame:SetScript(
	"OnUpdate",
	function(self, elapsed)
		for i, v in ipairs(DelayCallBacks) do
			if type(v.Time) ~= "nil" then
				v.Time = v.Time - elapsed
				if v.Time <= 0 then
					v.Func(v.RefTime)
					v.Time = nil
					table.remove(DelayCallBacks, i)
				end
			end
		end
		if getn(DelayCallBacks) == 0 then
			self:Hide()
		end
	end
)

_Questic_ADDON_Globals.SetDelay = function(Time, CallBackHandler)
	if type(Time) ~= "number" then
		Time = DelayTime
	end
	if type(CallBackHandler) == "function" then
		table.insert(DelayCallBacks, {Time = Time, RefTime = Time, Func = CallBackHandler})
		DelayFrame:Show()
	end
end

_Questic_ADDON_Globals.Round = function(Number, DecimalPlaces)
	if type(Number) ~= "number" then
		return 0
	end
	if type(DecimalPlaces) ~= "number" then
		DecimalPlaces = 0
	end
	Number = Number * 10 ^ DecimalPlaces
	if (Number - floor(Number)) >= 0.5 then
		Number = ceil(Number)
	else
		Number = floor(Number)
	end
	return Number / 10 ^ DecimalPlaces
end

_Questic_ADDON_Globals.CompareTables = function(Table1, Table2)
	if type(Table1) == "nil" and type(Table2) == "nil" then
		return 1
	elseif type(Table1) == "nil" or type(Table2) == "nil" then
		return 0
	elseif getn(Table1) == 0 and getn(Table2) == 0 then
		return 1
	elseif getn(Table1) == 0 or getn(Table2) == 0 then
		return 0
	else
		local Matches = 0
		for i, v in ipairs(Table1) do
			for ci, cv in ipairs(Table2) do
				if v == cv then
					Matches = Matches + 1
				end
			end
		end
		local Length = getn(Table1) > getn(Table2) and getn(Table1) or getn(Table2)
		return Matches / Length
	end
end

SLASH_QUESTIC1 = "/questic"
SlashCmdList["QUESTIC"] = function(msg)
	if msg == "rp" and Questic_ADDON_RoutePlanner then
		--Questic_ADDON_RoutePlanner:Show()
	elseif msg == "opt" then
		print(
			[[Questic options: 
/questic opt - Show questic /command options
/questic     - Open questic options menu]]
		)
	else
		if _Questic.OptionsMenu then
		_Questic.OptionsMenu.Call()
		end
	end
end
