local Widgets = _Avyr_GUI_Widgets_Lib
local insert,ipairs = table.insert, ipairs;

local Textures = {}

local function Release(self)
    self:SetVertexColor(1,1,1,1)
    self:SetTexCoord(0,1,0,1)
    self:SetGradientAlpha("VERTICAL", 1,1,1,1 ,1,1,1,1)
    self:SetTexture(nil)
    self:SetParent(Widgets)
    self:Hide()
    self.Released = true
end

Widgets.FetchTexture = function(self, Parent, Layer, Level)
    local Texture
    for i, v in ipairs(Textures) do
        if v.Released then
        Texture = v
        end
    end

    if not Texture then
    Texture = Widgets:CreateTexture(nil, Layer or "ARTWORK")
        insert(Textures,Texture)
        Texture.Release = Release
    end

    Texture.Released = false
    Texture:SetDrawLayer(Layer or "ARTWORK", Level or 0)
    Texture:ClearAllPoints()
    Texture:SetParent(Parent or Widgets)
    Texture:Show()

    return Texture
end

